# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from geometry_msgs/Transform.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class Transform(genpy.Message):
  _md5sum = "ac9eff44abf714214112b05d54a3cf9b"
  _type = "geometry_msgs/Transform"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['translation','rotation']
  _slot_types = ['geometry_msgs/Vector3','geometry_msgs/Quaternion']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       translation,rotation

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Transform, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.translation is None:
        self.translation = geometry_msgs.msg.Vector3()
      if self.rotation is None:
        self.rotation = geometry_msgs.msg.Quaternion()
    else:
      self.translation = geometry_msgs.msg.Vector3()
      self.rotation = geometry_msgs.msg.Quaternion()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_7d().pack(_x.translation.x, _x.translation.y, _x.translation.z, _x.rotation.x, _x.rotation.y, _x.rotation.z, _x.rotation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.translation is None:
        self.translation = geometry_msgs.msg.Vector3()
      if self.rotation is None:
        self.rotation = geometry_msgs.msg.Quaternion()
      end = 0
      _x = self
      start = end
      end += 56
      (_x.translation.x, _x.translation.y, _x.translation.z, _x.rotation.x, _x.rotation.y, _x.rotation.z, _x.rotation.w,) = _get_struct_7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_7d().pack(_x.translation.x, _x.translation.y, _x.translation.z, _x.rotation.x, _x.rotation.y, _x.rotation.z, _x.rotation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.translation is None:
        self.translation = geometry_msgs.msg.Vector3()
      if self.rotation is None:
        self.rotation = geometry_msgs.msg.Quaternion()
      end = 0
      _x = self
      start = end
      end += 56
      (_x.translation.x, _x.translation.y, _x.translation.z, _x.rotation.x, _x.rotation.y, _x.rotation.z, _x.rotation.w,) = _get_struct_7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
